package cn.ecpark.service.usergw.utils;

import java.io.InputStream;
import java.util.ArrayList;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

import org.junit.Assert;
import org.junit.Test;
import org.springframework.boot.test.context.TestComponent;
import org.yaml.snakeyaml.Yaml;

@TestComponent
public class TestYaml {
    @SuppressWarnings("unchecked")
    @Test
    public void TestLoadYaml() {
        Object inputStream = null;
        String[] gatewayConfigPathList = { "test-gateway.yml", "test-gateway.yaml", "test-Gateway.yml",
                "test-Gateway.yaml" };
        for (String gatewayConfigPath : gatewayConfigPathList) {
            inputStream = this.getClass().getResourceAsStream(gatewayConfigPath);
            if (inputStream != null) {
                break;
            }
        }

        Assert.assertNotNull(inputStream);
        Map<String, Object> configYaml = new Yaml().load((InputStream) inputStream);
        Assert.assertNotNull(configYaml);
        Object restfulYaml = configYaml.get("restful");
        Object dubboYaml = configYaml.get("dubbo");

        Assert.assertNotNull(restfulYaml);
        Assert.assertNotNull(dubboYaml);

        Assert.assertEquals(restfulYaml.getClass(), LinkedHashMap.class);
    
        List<String> defaultFilters = ((Map<String, List<String>>)restfulYaml).get("default-filters");
        Assert.assertNotNull(defaultFilters); 

        Assert.assertEquals(defaultFilters.size(), 1);
        Assert.assertEquals(defaultFilters.getClass(), ArrayList.class);
        Assert.assertEquals(defaultFilters.get(0), "AddResponseHeader=X-Response-Default-Foo, Default-Bar"); 

    }
}